unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, OleCtrls, SHDocVw, ExtCtrls, ToolWin, ImgList, StdCtrls,
  Buttons, ActnList;

type
  TfrmMain = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    WebBrowser1: TWebBrowser;
    Panel2: TPanel;
    Panel3: TPanel;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    btnHome: TToolButton;
    Edit1: TEdit;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    ToolBar2: TToolBar;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList2: TImageList;
    ActionList1: TActionList;
    actClientes: TAction;
    actFornecedores: TAction;
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure btnHomeClick(Sender: TObject);
    procedure WebBrowser1BeforeNavigate2(ASender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure actClientesExecute(Sender: TObject);
    procedure actFornecedoresExecute(Sender: TObject);
  private
    procedure CriarAba(clsForm: TFormClass; Index: Integer);
    function AbaExiste(NomeAba: string): Boolean;

    { Private declarations }
  public
    { Public declarations }
    procedure FecharAba(NomeAba: string);
  end;

var
  frmMain: TfrmMain;

implementation

uses ufrmClientes, ufrmFornecedores;

{$R *.dfm}

procedure TfrmMain.ToolButton1Click(Sender: TObject);
begin
  WebBrowser1.GoBack;
end;

procedure TfrmMain.ToolButton2Click(Sender: TObject);
begin
  WebBrowser1.GoForward;
end;

procedure TfrmMain.btnHomeClick(Sender: TObject);
var
  aFile: string;
begin
  aFile := ExtractFilePath(Application.ExeName) + 'index.htm';
  if FileExists(aFile) then
  begin
    WebBrowser1.Navigate(aFile);
    Edit1.Text := 'index.htm';
  end
  else
    ShowMessage('Arquivo no encontrado');
end;

procedure TfrmMain.WebBrowser1BeforeNavigate2(ASender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var
  Comando: string;
  ColonPos: Integer;
begin
  ColonPos := Pos(':', URL);
  if ColonPos > 0 then
  begin
    Cancel := True;
    Comando := Copy(URL, 1, ColonPos - 1);
    if Comando = 'clientes' then
      actClientes.Execute
    else if Comando = 'fornecedores' then
      actFornecedores.Execute
    else
      Cancel := False;
  end;
end;

procedure TfrmMain.actClientesExecute(Sender: TObject);
begin
  CriarAba(TfrmClientes, 4);
end;

procedure TfrmMain.actFornecedoresExecute(Sender: TObject);
begin
  CriarAba(TfrmFornecedores, 3);
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  WebBrowser1.Navigate(Edit1.Text);
end;

procedure TfrmMain.CriarAba(clsForm: TFormClass; Index: Integer);
var
  TabSheet: TTabSheet;
  Form: TForm;
begin
  Form := clsForm.Create(TabSheet);

  if AbaExiste(Form.Caption) then
    Exit;

  TabSheet := TTabSheet.Create(Self);

  with TabSheet do
  begin
    PageControl := PageControl1;
    Caption := Form.Caption;
    ImageIndex :=  Index;
  end;

  with Form do
  begin
    Align := alClient;
    BorderStyle := bsNone;
    Parent := TabSheet;
    Show;
  end;

  PageControl1.ActivePage := TabSheet;
end;

function TfrmMain.AbaExiste(NomeAba: string): Boolean;
var
  i: Integer;
  Aba: TTabSheet;
begin
  Result := False;
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    if PageControl1.Pages[i].Caption = NomeAba then
    begin
      Aba := PageControl1.Pages[i];
      PageControl1.ActivePage := Aba;
      Result := True;
      break;
    end;
  end;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  btnHome.Click;
end;

procedure TfrmMain.FecharAba(NomeAba: string);
var
  i: integer;
  Aba: TTabSheet;
begin
  for i := 0 to PageControl1.PageCount - 1 do
  begin
    if PageControl1.Pages[i].Caption = NomeAba then
    begin
      Aba := PageControl1.Pages[i];
      Aba.Destroy;
      PageControl1.ActivePageIndex := 0;
      break;
    end;
  end;
end;

end.
